﻿// tipupgrader.cpp : 콘솔 응용 프로그램에 대한 진입점을 정의합니다.
//

#include "stdafx.h"
#include "tipupgrader.h"
#include "../../common/ConfigXmlParser.h"
#include "HttpClient/httpclient.h"
#define TIXML_USE_STL
#include "tinyxml.h"
#include "XMLUtil.h"
#include "Resource.h"
#include <vector>
#include "NaverUtil.h"
#include "../../common/drive.h"
#include "unzip.h"
#include "TlHelp32.h"

#include "../../common/corevalueregistryconst.h"
#include "../../common/Registry.h"

//Notice -- this message MUST be same with the value defined in NeMessenger\define.h
//          because there is NO same config file for nTalk and update project, so define in two files.
#define UM_NTALK_NOTIFY_VERSION			(WM_USER + 7020)

#pragma comment(lib, "comsuppw.lib")
#include <comutil.h>

#define AGREEMENT_CHANGE
#ifdef AGREEMENT_CHANGE
#include "./mvc/UpgraderApplication.h"
#endif // #ifdef AGREEMENT_CHANGE

using namespace tipupgrader;
using namespace tipcommon;
const TCHAR NTALKUPDATER_GUID[] = _T("678F4EA5-8292-4dff-8202-D5F8EEAD66E2");
const TCHAR THIS_GUID[] = _T("EE77F315-BA0A-4ec2-A88F-3A0D6121B831");
const TCHAR NSIS_GUID[] = _T("497B2C88-8CC9-4552-9914-CA161327C903");
const CString TARGET_NTALKBIZ("ntalkbiz"); 
const CString TARGET_UPDATER("updater"); 
#ifdef DEBUG
	const TCHAR NTALKBIZ_UPGRADER[] = _T("NtalkbizUpgraderD.exe");
	const TCHAR NTALKBIZ_FILENAME[] = _T("Ntalkbiz.exe");
	const TCHAR NTOOLSUPDATER_FILENAME[] = _T("NtalkbizUpgraderLauncherD.exe");;
#else
	const TCHAR NTALKBIZ_UPGRADER[] = _T("NtalkbizUpgrader.exe");
	const TCHAR NTALKBIZ_FILENAME[] = _T("Ntalkbiz.exe");
	const TCHAR NTOOLSUPDATER_FILENAME[] = _T("NtalkbizUpgraderLauncher.exe");
#endif


HMODULE _hModule = NULL;

BOOL IsIEVersion70()
{
	CRegKey regkey;
	if ( regkey.Open(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Internet Explorer\\Version Vector"), KEY_READ ) != ERROR_SUCCESS )
		return FALSE;

	TCHAR szIEVersion[MAX_PATH];
	ULONG ulSize = MAX_PATH;
	regkey.QueryStringValue(_T("IE"), szIEVersion, &ulSize);

	if ( szIEVersion[0] >= _T('7') )
		return TRUE;
	else
		return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)		
{	
	CString strRootPath = Registry::ReadString(HKEY_CURRENT_USER, REGVAL_ROOTPATH, _T("Path"));
	strRootPath += _T("\\Update");
	::SetCurrentDirectory(strRootPath);

	USES_CONVERSION;
#ifdef AGREEMENT_CHANGE
	_hModule = hInstance;
#endif // #ifdef AGREEMENT_CHANGE
	int commandLineCount=0;
	LPWSTR * commandLines = CommandLineToArgvW(CT2W(GetCommandLine()), &commandLineCount);
	std::vector<CString> cmdParameter;
	for (int i = 1; i < commandLineCount; i++)
	{
		cmdParameter.push_back(CString(commandLines[i]));
	}


	Upgrader upgrader(hInstance, &cmdParameter);
	return upgrader.Run();
}
	
namespace tipupgrader
{
	int Upgrader::Run()
	{
		if (FALSE == m_util.IsSingleInstance(THIS_GUID))
		{
			DisplayPreviousWindow();
			return 0;
		}

		if (FALSE == m_util.CheckNetwork())
		{
			m_util.DeleteThisMutex();

			return 0;
		}


		RunUpdateNTalk(TARGET_NTALKBIZ);
		RunUpdateUpgrader(TARGET_UPDATER); 

		m_util.DeleteThisMutex();

		return 0;
	}

	BOOL Upgrader::RunUpdateNTalk(LPCTSTR target) 
	{
		BOOL result = FALSE;

		if (FALSE == LoadServerInfo(target))
		{
			return FALSE;
		}

		if (FALSE == LoadLocalInfo(target))
		{
			return FALSE;
		}

		if (IsVersionChanged())
		{
			if (UpgradeNTalk(target))
			{
				SaveVersion(target);
				RunProgram(NTALKBIZ_FILENAME, NULL);
			}

			result = TRUE;
		}

		return result; 
	}

	BOOL Upgrader::RunUpdateUpgrader(LPCTSTR target) 
	{
		BOOL result = FALSE;

		if (FALSE == LoadServerInfo(target))
		{
			return result;
		}

		if (FALSE == LoadLocalInfo(target))
		{
			return FALSE;
		}

		if (IsVersionChanged())
		{
			if (UpgradeAgent())
			{
				SaveVersion(target);
				RunProgram(NTALKBIZ_UPGRADER, NULL);
			}

			result = TRUE;
		}
		else
		{
			NotifyNTalkVersionInfo(target, TRUE);
		}

		return result; 
	}

	BOOL Upgrader::NotifyNTalkVersionInfo(LPCTSTR target, BOOL bSameVersion)
	{
		BOOL bRet = FALSE;
		HWND hWndNTalk = ::FindWindow(TEXT("#32770"), TEXT("Ntalk biz"));
		if (hWndNTalk != NULL)
		{
			bRet = ::PostMessage(hWndNTalk, UM_NTALK_NOTIFY_VERSION, (WPARAM)bSameVersion, 0);
		}
		else
		{
			ATLASSERT(FALSE && _T("Can not find Ntalk biz window"));
		}
		return bRet;
	}

	BOOL Upgrader::LoadServerInfo(LPCTSTR target)
	{
		CString configFile = m_util.GetConfigFilePath(); 

		TCHAR serverfilePath[tipbase::MAXURL] = {0, };
		if (FALSE == ConfigXmlParser::GetURL(target, configFile, Element::ServerInfo, serverfilePath, tipbase::MAXURL, TRUE))
		{
			return FALSE;
		}

		tipbase::GenericHTTPClient httpClient;
		if( httpClient.Request(NULL, serverfilePath) == TRUE)
		{
			TiXmlDocument xmlDoc;
			xmlDoc.Parse((const char*)httpClient.QueryHTTPResponse());
			TiXmlElement* element = xmlDoc.FirstChildElement("root");
			if (!element)
				return FALSE; 

			element = element->FirstChildElement((CStringA)target);
			if (element == NULL)
				return FALSE; 

			TCHAR version[tipbase::MAXSTEXT] = {0, };
			if(FALSE == XMLUtil::GetValue(element, "version", version, tipbase::MAXSTEXT))
			{
				_tcscpy_s(version, tipbase::MAXSTEXT, _T("serverversion loadfail"));
			}

			TCHAR url[tipbase::MAXURL] = {0, };
			if (FALSE == XMLUtil::GetValue(element, "url", url, tipbase::MAXURL))
				return FALSE;

			TCHAR deadline[tipbase::MAXDEADLINE] = {0, };
			XMLUtil::GetValue(element, "deadline", deadline, tipbase::MAXDEADLINE);

			TCHAR description[tipbase::MAXDESCRIPTION] = {0, };
			XMLUtil::GetValue(element, "description", description, tipbase::MAXDESCRIPTION);

			m_deadLine = deadline;
			m_upgradeDescription = description;

			m_serverVersion = version;
			m_setupFilePath = url;

			return TRUE;
		}

		return FALSE;
	}
	BOOL Upgrader::LoadReCheckServerInfo( LPCTSTR target )
	{
		CString configFile = m_util.GetConfigFilePath(); 

		TCHAR serverfilePath[tipbase::MAXURL] = {0, };
		if (FALSE == ConfigXmlParser::GetURL(target, configFile, Element::ServerInfo, serverfilePath, tipbase::MAXURL, TRUE))
		{
			return FALSE;
		}

		tipbase::GenericHTTPClient httpClient;
		if( httpClient.Request(NULL, serverfilePath) == TRUE)
		{
			TiXmlDocument xmlDoc;
			xmlDoc.Parse((const char*)httpClient.QueryHTTPResponse());
			TiXmlElement* element = xmlDoc.FirstChildElement("root");
			if (!element)
				return FALSE; 

			element = element->FirstChildElement((CStringA)target);
			if (element == NULL)
				return FALSE; 

			TCHAR version[tipbase::MAXSTEXT] = {0, };
			if(FALSE == XMLUtil::GetValue(element, "version", version, tipbase::MAXSTEXT))
			{
				_tcscpy_s(version, tipbase::MAXSTEXT, _T("serverversion loadfail"));
			}

			TCHAR url[tipbase::MAXURL] = {0, };
			if (FALSE == XMLUtil::GetValue(element, "url", url, tipbase::MAXURL))
				return FALSE;

			TCHAR deadline[tipbase::MAXDEADLINE] = {0, };
			XMLUtil::GetValue(element, "deadline", deadline, tipbase::MAXDEADLINE);

			TCHAR description[tipbase::MAXDESCRIPTION] = {0, };
			XMLUtil::GetValue(element, "description", description, tipbase::MAXDESCRIPTION);

			//m_deadLine = deadline;
			//m_upgradeDescription = description;

			m_checkServerVersion = version;
			//m_setupFilePath = url;

			return TRUE;
		}

		return FALSE;

	}

	BOOL Upgrader::LoadLocalInfo(LPCTSTR target)
	{
		CString configFile = m_util.GetConfigFilePath();

		TCHAR version[tipbase::MAXSTEXT] = {0, };
		if (FALSE == ConfigXmlParser::GetURL(target, configFile, Element::Version, version, tipbase::MAXSTEXT, TRUE))
		{
			return FALSE;
		}

		m_localVersion = version;

		return TRUE;
	}

	bool Upgrader::TrayIcoRefresh()
	{
		try
		{
			HANDLE 			m_hProcess;
			LPVOID 			m_lpData;
			TBBUTTON		tb;
			TRAYDATA		tray;
			DWORD 			dwTrayPid;
			int				TrayCount;

			// Tray 의 윈도우 핸들 얻기
			HWND m_hTrayWnd = FindTrayToolbarWindow();
			if (m_hTrayWnd == NULL)
				return false;

			TrayCount = (int)::SendMessage(m_hTrayWnd, TB_BUTTONCOUNT, 0, 0);
			GetWindowThreadProcessId(m_hTrayWnd, &dwTrayPid);
			m_hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwTrayPid);
			if (!m_hProcess)
				return false;

			m_lpData = VirtualAllocEx(m_hProcess, NULL, sizeof (TBBUTTON), MEM_COMMIT, PAGE_READWRITE);
			if (!m_lpData)
				return false;

			for(int i = 0; i < TrayCount; i++)
			{
				::SendMessage(m_hTrayWnd, TB_GETBUTTON, i, (LPARAM)m_lpData);	

				ReadProcessMemory(m_hProcess, m_lpData, (LPVOID)&tb, sizeof (TBBUTTON), NULL);
				ReadProcessMemory(m_hProcess, (LPCVOID)tb.dwData, (LPVOID)&tray, sizeof (tray), NULL);

				DWORD dwProcessId = 0;
				GetWindowThreadProcessId(tray.hwnd, &dwProcessId);

				if (dwProcessId == 0)
				{
					NOTIFYICONDATA	icon;
					icon.cbSize	= sizeof(NOTIFYICONDATA);
					icon.hIcon	= tray.hIcon;
					icon.hWnd	= tray.hwnd;
					icon.uCallbackMessage = tray.uCallbackMessage;
					icon.uID	= tray.uID;

					Shell_NotifyIcon(NIM_DELETE, &icon);
				}
			}

			VirtualFreeEx(m_hProcess, m_lpData, NULL, MEM_RELEASE);
			CloseHandle(m_hProcess);       

			return true;
		}
		catch (...)
		{
			return false;
		}
	}

	BOOL Upgrader::UpgradeNTalk(LPCTSTR target)
	{
		BOOL bSuccess = FALSE;
		HANDLE nsisMutex = NULL;

		if (FALSE == m_util.CreateMutex(NSIS_GUID, nsisMutex))
			return bSuccess;

		int bNtalkPrepared = PrepareToUpdate();
		if (IDOK != bNtalkPrepared)
		{
			if (nsisMutex)
				m_util.DeleteMutex(nsisMutex);

			return FALSE;  
		}

		//메시지 박스가 떠 있는 상태 동안 배포가 취소되었음을 체크한다.
		if(IsUpdateCancel(target, nsisMutex))
			return FALSE;


		//NTalk biz 종료
		if (FALSE == KillNtalkbizProcess())
		{
			MessageBox(NULL, _T("업데이트에 실패했습니다.\n다음에 업데이트가 진행됩니다."), _T("업데이트 실패"), MB_OK | MB_ICONINFORMATION);
			if (nsisMutex)
				m_util.DeleteMutex(nsisMutex);

			TrayIcoRefresh();
			return FALSE;
		}


		StartTrayAnimation();
		CString path;
		

		for(int i=0; i < 5; i++) // 최대 5회 재시도.
		{
			path = DownloadUpdateFile();
			if (FALSE == LoadReCheckServerInfo(target))
			{
				i = 5;
			}
			if (m_serverVersion == m_checkServerVersion)
			{
				i = 5;
			}
			else
			{
				if (FALSE == LoadServerInfo(target))
				{
					i = 5;
				}
			}
		}
		

		if (path.GetLength() > 0)
		{
			bSuccess = RunUpgraderFile(path, _T("/SILENT"));
		}

		if (nsisMutex)
			m_util.DeleteMutex(nsisMutex);

		TrayIcoRefresh();
		EndTrayAnimation();

		return bSuccess;
	}

	BOOL Upgrader::UpgradeAgent()
	{
		BOOL bSuccess = FALSE;
		HANDLE nsisMutex = NULL;
		if (FALSE == m_util.CreateMutex(NSIS_GUID, nsisMutex))
			return bSuccess;

		if (m_util.IsRunProgram(NTALKUPDATER_GUID))
		{
			m_bProgramQuit = FALSE;
			m_bIPCConnect = FALSE;
			tipbase::IPCStringKey host(_T("NtalkbizUpgraderUpgrader"));
			m_server.Create(&host);
			tipbase::IPCStringKey key( _T("NtalkbizUpgrader"));
			IIPCHandle* handle = m_server.Find(&key, &m_receiveCallback);
			TCHAR connectData[] = _T("request_connect");
			handle->Write((const BYTE*)connectData, (_tcslen(connectData)+1)*sizeof(TCHAR));

			Sleep(500); // 연결을 기다린다
			if (m_bIPCConnect == FALSE)
			{
				if (nsisMutex)
				{
					m_util.DeleteMutex(nsisMutex);
				}
				return bSuccess;
			}

			TCHAR quitCommandData[] = _T("quit_command");
			handle->Write((const BYTE*)quitCommandData, (_tcslen(quitCommandData)+1)*sizeof(TCHAR));
			while(m_bProgramQuit == FALSE)
			{
				Sleep(1000);			
				handle->Write((const BYTE*)quitCommandData, (_tcslen(quitCommandData)+1)*sizeof(TCHAR));
			}
		}
		
		CString path = DownloadUpdateFile();
		
		if (path.GetLength() > 0)
		{
			bSuccess = RunUpgraderFile(path, _T("/SILENT"));
		} 

		if (nsisMutex)
			m_util.DeleteMutex(nsisMutex);

		return bSuccess;
	}

	int Upgrader::PrepareToUpdate()
	{
		UINT option = GetUpdateButtonOption();

		int result = MessageBox(NULL, _T("최신버전의 Ntalk biz가 나왔습니다.\n[확인]버튼을 눌러 업데이트 해주세요."), _T("Ntalk biz 업데이트"), option | MB_ICONINFORMATION);
		
		return result;
	}

	BOOL Upgrader::KillNtalkbizProcess()
	{
		BOOL bResult = TRUE;
		PROCESSENTRY32 entry; 
		entry.dwSize = sizeof(PROCESSENTRY32); 
		CString processName = (CString)NTALKBIZ_FILENAME; 

		HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL); 

		if (Process32First(snapshot, &entry) == TRUE) 
		{ 
			while (Process32Next(snapshot, &entry) == TRUE) 
			{ 
				if (processName.CompareNoCase(entry.szExeFile) == 0) 
				{
					HANDLE hProcess;
					hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, entry.th32ProcessID);

					if (TerminateProcess(hProcess, 0))
					{
						bResult = TRUE;
					}
					else
					{
						bResult = FALSE;
					}

					break;
				} 
			} 
		} 

		CloseHandle(snapshot);

		return bResult;
	}

	BOOL Upgrader::SaveVersion(LPCTSTR target)
	{

		CString configFile = m_util.GetConfigFilePath(); 
		TiXmlDocument doc((CStringA)configFile); 
		bool bLoad = doc.LoadFile(); 
		if (bLoad) 
		{ 
 			TiXmlElement* pElement = doc.FirstChildElement("root");
			if (!pElement)
				return FALSE; 

			pElement = pElement->FirstChildElement("locale");
			pElement = pElement->FirstChildElement((CStringA)target);
			if (!pElement)
				return FALSE; 

			pElement = pElement->FirstChildElement("version");
			if (!target) 
				return FALSE; 

			TiXmlNode* pChildNode = pElement->FirstChild();
			if (!pChildNode)
				return FALSE; 
			
			pChildNode->SetValue((CStringA)m_localVersion);
			doc.SaveFile((CStringA)configFile);
		} 
		return TRUE; 
	}

	BOOL Upgrader::LicenseInfoCopyToAppData()
	{
		TCHAR szAppDataLicenseInfoPath[MAX_PATH * 4];
		if( ! Drive::GetCurrentUserLocalStorageFolderFileName(szAppDataLicenseInfoPath, sizeof(szAppDataLicenseInfoPath), _T("Ntools_license_Info.xml")) )
		{
			::OutputDebugString(_T("GetCurrentUserLocalStorageFolderFileName() returned failure! IN LicenseInfoCopyToAppData()\n"));	
		}
		if( ATLPath::FileExists(szAppDataLicenseInfoPath) == FALSE )
		{
			ATLPath::RemoveFileSpec(szAppDataLicenseInfoPath);
			::SHCreateDirectoryEx( NULL, szAppDataLicenseInfoPath, NULL );
	
			CString strSourcePath = m_util.GetLicenseInfoPath();	
			CString strTargetPath = szAppDataLicenseInfoPath;
			strTargetPath += _T("\\Ntools_license_Info.xml");

			::CopyFile(strSourcePath, strTargetPath, TRUE);
		}
		return TRUE;
	}

	BOOL Upgrader::RunUpgraderFile(LPCTSTR filepath, LPCTSTR runParameter)
	{
		CString newParameter;
		MakeParameter(newParameter, runParameter);
		HANDLE waitProcessHandle = m_util.ExecuteProgram(filepath, newParameter);

		DWORD ret = WAIT_TIMEOUT;
		MSG msg;
		DWORD ExitCode = 1;
		while(ret == WAIT_TIMEOUT)
		{
			ret = ::WaitForSingleObject(waitProcessHandle, 100);
			if (::PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE) ||
				::PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE)) 
			{				
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			if (ret == WAIT_OBJECT_0)
				GetExitCodeProcess(waitProcessHandle, &ExitCode);
		}
		return (ExitCode == 0);
	}

	CString Upgrader::DownloadUpdateFile()
	{
		tipbase::GenericHTTPClient httpClient;
		TCHAR tempPath[MAX_PATH] = {0, };
		m_util.GetTemporaryPath(tempPath, MAX_PATH);

		CString fileName = ATLPath::FindFileName(m_setupFilePath);
		CString filePath = tempPath;
		filePath += _T("\\");
		filePath += fileName;

		if(httpClient.Request(NULL, m_setupFilePath, GenericHTTPClient::RequestGetMethod, filePath))
			return filePath;

		return CString();
	}

	CString Upgrader::DownloadZipFile()
	{
		tipbase::GenericHTTPClient httpClient;
		TCHAR tempPath[MAX_PATH] = {0, };
		m_util.GetTemporaryPath(tempPath, MAX_PATH);

		CString fileName = ATLPath::FindFileName(m_setupFilePath);
		CString filePath = tempPath;
		filePath += _T("\\");
		filePath += fileName;

		if(httpClient.Request(NULL, m_setupFilePath, GenericHTTPClient::RequestGetMethod, filePath))
			return filePath;

		return CString();
	}

	CString Upgrader::DownloadLicenseFile()
	{
		tipbase::GenericHTTPClient httpClient;
		
		TCHAR szAppDataLicenseInfoPath[MAX_PATH * 4];
		if( ! Drive::GetCurrentUserLocalStorageFolderFileName(szAppDataLicenseInfoPath, sizeof(szAppDataLicenseInfoPath), _T("Ntools_license_Info.xml")) )
		{
			
		}
		CString strLicenseInfoPath(szAppDataLicenseInfoPath);

		if(httpClient.Request(NULL, _T("http://cdn.naver.com/naver/tools/updater/serviceinfo/Ntools_license_Info.xml"), GenericHTTPClient::RequestGetMethod, strLicenseInfoPath))
			return strLicenseInfoPath;

		return CString();
	}

	HANDLE Upgrader::RunProgram(LPCTSTR programName, LPCTSTR parameter)
	{
		CString filePath = Registry::ReadString(HKEY_CURRENT_USER, REGVAL_ROOTPATH, _T("Path"));;

		if (0 == lstrcmp(NTALKBIZ_UPGRADER, programName))
		{
			filePath += _T("\\Update\\");
		}
		else
		{
			filePath += _T("\\");
		}

		filePath += programName;

 		CString runParameter;
		MakeParameter(runParameter, parameter);

		return m_util.ExecuteProgram(filePath, runParameter);
	}

	void Upgrader::StartTrayAnimation()
	{
		m_TrayIconWnd.Create();
	}

	void Upgrader::EndTrayAnimation()
	{
		m_TrayIconWnd.Destroy();
	}

	void Upgrader::MakeParameter(CString& dstParameter, LPCTSTR srcParameter)
	{
		if (srcParameter)
		{
			dstParameter += srcParameter;
		}
		std::vector<CString>::iterator it = m_CmdParameter->begin();
		for (; it != m_CmdParameter->end(); it++)
		{
			dstParameter += _T(" ");
			dstParameter += (*it);
		}
	}

	BOOL Upgrader::IsAutoUpgrade()
	{
		BOOL bAutoUpgrade = FALSE;
		std::vector<CString>::iterator it = m_CmdParameter->begin();
		for (; it != m_CmdParameter->end(); it++)
		{
			if (0 == (*it).Compare(_T("/A")))
				bAutoUpgrade = TRUE;
		}
		return bAutoUpgrade;
	}

	BOOL Upgrader::IsSilentUpgrade()
	{
		BOOL bSilentUpgrade = FALSE;
		std::vector<CString>::iterator it = m_CmdParameter->begin();
		for (; it != m_CmdParameter->end(); it++)
		{
			if (0 == (*it).Compare(_T("/M")))
				bSilentUpgrade = TRUE;
		}
		return bSilentUpgrade;
	}

	typedef CString _String;
	typedef std::vector<CString > _StringList;
	static LPCTSTR kVerskonToken = _T(".,");

	static int _StringTokenize( const _String& text, LPCTSTR szToken, OUT _StringList& outList )
	{
		outList.clear();
		if ( text.IsEmpty())
		{
			return 0;
		}

		int pos = 0;
		CAtlString tok = text.Tokenize(szToken, pos);
		while(tok.GetLength())
		{
			outList.push_back( tok );
			tok = text.Tokenize(szToken, pos);
		}
		return (int)outList.size();
	}

	static BOOL IsVersionUpdatable( LPCTSTR szLocal, LPCTSTR szServer )
	{
		CAtlString strLocal = szLocal, strServer = szServer;
		_StringList local, server;

		int localVersionLen = _StringTokenize(strLocal, kVerskonToken, local); 
		int serverVersionLen = _StringTokenize(strServer, kVerskonToken, server); 

		if(localVersionLen == serverVersionLen)
		{
			for(int i = 0; i < serverVersionLen; i++)
			{
				if( _ttoi(server[i]) > _ttoi(local[i]) )
				{
					return TRUE;
				}
			}
		}
		else 
			return TRUE; 

		return FALSE;
	}

	BOOL Upgrader::IsVersionChanged()
	{		
		BOOL bChanged = IsVersionUpdatable(m_localVersion, m_serverVersion);
		if (bChanged == TRUE) 
			m_localVersion = m_serverVersion; 
		return bChanged; 
	}

	BOOL Upgrader::UpdateAgent(CString path)
	{
		BOOL result = FALSE; 
		TCHAR szCurDir[_MAX_PATH];
		GetCurrentDirectory(DIM(szCurDir), szCurDir);

		TCHAR szDrive[_MAX_DRIVE];  
		TCHAR szDir[_MAX_DIR];
		TCHAR szFName[_MAX_FNAME];
		TCHAR szExt[_MAX_EXT];

		_wsplitpath_s(path, szDrive, szDir, szFName, szExt);	
		CString strTmpDir = (CString)szCurDir + _T("\\") + szFName + ("_tmp"); 
		CreateDirectory(strTmpDir, 0);

		result = UnZipFile(path, strTmpDir);

		CString strCmd = _T("");
		char chCmdBuff[_MAX_PATH] = {0,};
		char chTmpDirBuff[_MAX_PATH] = {0,};
		char chCurDirBuff[_MAX_PATH] = {0,};
		char chDownloadPathBuff[_MAX_PATH] = {0,};

		strcpy_s(chCurDirBuff, _MAX_PATH, (char*)_bstr_t(szCurDir));
		strcpy_s(chTmpDirBuff, _MAX_PATH, (char*)_bstr_t(strTmpDir));
		strcpy_s(chDownloadPathBuff, _MAX_PATH, (char*)_bstr_t(path));

		WIN32_FIND_DATA wFindData;
		CString strSearchFile;
		BOOL bResult = TRUE;
		strSearchFile.Format(_T("%s\\*.*"), strTmpDir);
		HANDLE hCopyHandle = FindFirstFile(strSearchFile, &wFindData);
		if(hCopyHandle == INVALID_HANDLE_VALUE)
			return FALSE;

 		// Copy unzipped files 		
		while(bResult)
		{
			if(wFindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
			}
			else
			{
				CString strDest, strSrc;
				strSrc.Format(_T("%s\\%s"), strTmpDir, wFindData.cFileName);
				strDest.Format(_T("%s\\%s"), szCurDir, wFindData.cFileName);
				OutputDebugString(strDest);
				if(CopyFile(strSrc, strDest, FALSE) == FALSE)
				{
					bResult = FALSE;
					break;
				}
				//Sleep(1000);
			}			

			bResult = FindNextFile(hCopyHandle, &wFindData);
		}
		FindClose(hCopyHandle);

// 		strCmd.Format(_T("/c xcopy /s /y \"%s\" \"%s\""), strTmpDir, (CString)szCurDir);
// 		if (NULL != ShellExecute(NULL, _T("open"), _T("cmd"), strCmd, NULL, SW_HIDE)) 
// 			result = TRUE; 		
// 		else 
// 			result = FALSE; 

		// Delete a temporary folder
		strCmd.Format(_T("/c rmdir /s /q \"%s\""), (CString)chTmpDirBuff);
		if (NULL != ShellExecute(NULL, _T("open"), _T("cmd"), strCmd, NULL, SW_HIDE)) 
			result = TRUE; 
		else 
			result = FALSE; 

		// Delete a zip file 
		strCmd.Format(_T("/c del \"%s\""), (CString)chDownloadPathBuff);
		if (ShellExecute(NULL, _T("open"), _T("cmd"), strCmd, NULL, SW_HIDE))
			result = TRUE; 		
		else 
			result = FALSE; 

		return result; 
	}

	BOOL Upgrader::UnZipFile(CString path, CString tmpDir) 
	{
		BOOL result = FALSE; 
		ZIPENTRY ze; 
		HZIP hz = OpenZip(path, 0);
		GetZipItem(hz, -1, &ze); 
		SetUnzipBaseDir(hz, tmpDir);

		int numItems = ze.index;
		if (numItems > 0)
		{
			for (int zi = 0; zi < numItems; zi++)
			{ 
				GetZipItem(hz, zi, &ze); 
				UnzipItem(hz, zi, ze.name);
			}
			result = TRUE; 
		}
		CloseZip(hz);
		return result; 
	}

	UINT Upgrader::GetUpdateButtonOption()
	{
		UINT result = MB_OKCANCEL;
		
		SYSTEMTIME currentTime;
		GetSystemTime(&currentTime);

		CString strCurrentTime;
		strCurrentTime.Format(_T("%04d%02d%02d%02d"), currentTime.wYear
								, currentTime.wMonth
								, currentTime.wDay
								, currentTime.wHour);

		if (strCurrentTime.Compare(m_deadLine) < 0)
		{
			result = MB_OK;
		}

		return result;
	}

	BOOL CALLBACK EnumWindowsProc(HWND windowHandle, LPARAM lParam)
	{     
		DWORD searchedProcessId = (DWORD)lParam;  
		// This is the process ID we search for (passed from BringToForeground as lParam)    
		DWORD windowProcessId = 0;     
		GetWindowThreadProcessId(windowHandle, &windowProcessId); 
		// Get process ID of the window we just found     
		if (searchedProcessId == windowProcessId)  
		{  
			// Is it the process we care about?       
			SetForegroundWindow(windowHandle);  
			// Set the found window to foreground       
			return FALSE;  
			// Stop enumerating windows     
		}     
		return TRUE;  
		// Continue enumerating
	}  
	void BringToForeground(DWORD processId)  
	{    
		EnumWindows(&EnumWindowsProc, (LPARAM)processId); 
	}

	void Upgrader::DisplayPreviousWindow()
	{
		PROCESSENTRY32 entry; 
		entry.dwSize = sizeof(PROCESSENTRY32); 
		CString processName = (CString)NTOOLSUPDATER_FILENAME; 

		HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL); 

		if (Process32First(snapshot, &entry) == TRUE) 
		{ 
			while (Process32Next(snapshot, &entry) == TRUE) 
			{ 
				if (processName.CompareNoCase(entry.szExeFile) == 0) 
				{
					BringToForeground(entry.th32ProcessID);
					
					break;
				} 
			} 
		} 

		CloseHandle(snapshot);

	}

	BOOL Upgrader::IsUpdateCancel( LPCTSTR target, HANDLE nsisMutex )
  	{
		BOOL bReturn = FALSE;
		// 파일 다운로드 전에 다시한번 버전 체크를 한다.
		if (FALSE == LoadServerInfo(target))
		{
			if (nsisMutex)
				m_util.DeleteMutex(nsisMutex);
			bReturn = TRUE;
		}

		if (FALSE == LoadLocalInfo(target))
		{
			if (nsisMutex)
				m_util.DeleteMutex(nsisMutex);
			bReturn = TRUE;
		}

		if (!IsVersionChanged())
		{
			if (nsisMutex)
				m_util.DeleteMutex(nsisMutex);
			bReturn = TRUE;
		}
		return bReturn;
	}



};
